//  
// cdcanl.C
//
// 

TFile *foutp;

int cdcanl(Int_t run = 0)
{
  gROOT->Reset();
  
  if( strncmp(gSystem->HostName(),"ccjlc",5)  != 0 ) {
    if( strncmp(gSystem->Getenv("OSTYPE"),"hpux",4) == 0 ) {
      gSystem->Load("../../../lib/libCDCUtils.sl");
      gSystem->Load("../../../lib/libCDCRawData.sl");
      gSystem->Load("../../../lib/libCDCClusterMaker.sl");
      gSystem->Load("../../../lib/libCDCHitMaker.sl");
      gSystem->Load("../../../lib/libCDCTrackMaker.sl");
    }
    else {
      gSystem->Load("../../../lib/libCDCUtils.so");
      gSystem->Load("../../../lib/libCDCRawData.so");
      gSystem->Load("../../../lib/libCDCClusterMaker.so");
      gSystem->Load("../../../lib/libCDCHitMaker.so");
      gSystem->Load("../../../lib/libCDCTrackMaker.so");
    }
  }
    
  JSFSteer *jsf = new JSFSteer();

  foutp = new TFile("jsf.root","RECREATE"); //  Output file.
  TFile & fout = *foutp;
  
  if (!run) run = jsf->Env()->GetValue("JSFSteer.RunNo",36);  
  Char_t fname[64];
  sprintf(fname,"run%4.4d.root",run);
  TFile file(fname);  // Input file

  jsf->SetInput(file);
  jsf->SetOutput(fout);

  Int_t nevent=jsf->Env()->GetValue("JSFSteer.Nevent",300);  
  Int_t minevt=1;
  Int_t maxevt=minevt+nevent;

  CDCFADCCalibration fadccalib("../../../data/fadccalib.dat");
  CDCClusterMaker *clust = new CDCClusterMaker(&fadccalib);
  clust->UseConstPed();
  CDCTimeToXRelation xtcalib("../../../data/xtcalib.dat");
  CDCHitMaker *hit = new CDCHitMaker(&xtcalib);
  CDCTrackMaker *track = new CDCTrackMaker();

#if 0
  CDCRawHist      *hist  = new CDCRawHist();
#endif
#if 0
  CDCClusterHist  *hist  = new CDCClusterHist();
#endif
#if 0
  CDCTrackHist    *hist  = new CDCTrackHist();
#endif

  jsf->Initialize();
  CDCRawData *raw=(CDCRawData*)jsf->FindModule("CDCRawData");

  jsf->BeginRun(run);      // Set run number
  for(Int_t ev=minevt;ev<=maxevt;ev++){
    Int_t ib;
    if( ! (ib=jsf->GetEvent(ev)) ) break ;
#if 0
    ((CDCRawDataBuf*)raw->EventBuf())->GetHeader()->DebugPrint();
#endif
    if( ! jsf->Process(ev) ) break ;
#if 1
    ((CDCClusterBuf*)clust->EventBuf())->DebugPrint();
    ((CDCHitBuf*)hit->EventBuf())->DebugPrint();
    ((CDCTrackBuf*)track->EventBuf())->DebugPrint();
#endif
    jsf->FillTree();
    jsf->Clear();
  }

  jsf->Terminate();
  fout.Write();

}
